/* $Id:  $
 *
 * PDFlib PLOP: PDF Linearization, Optimization, Protection
 * decryption sample
 */

import java.io.PrintWriter;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServlet;

import com.pdflib.PLOPException;
import com.pdflib.plop;

public class DecryptServlet extends HttpServlet {
    private static final long serialVersionUID = -8640936781054764813L;

    public void service(ServletRequest request, ServletResponse response) 
            throws ServletException {
        plop plop = null;

        try {
            /* parameters for the input document */
            final String in_filename = "PLOP-datasheet-encrypted.pdf";
            final String in_password = "DEMO";
            
            /* parameters for the output document */
            final String out_filename = "";
            final String out_master = "";
            final String out_user = "";
            final String permissions = "";

            plop = new plop();

            /*
             * Set up the search path so the document generated by the encrypt
             * sample can be found.
             */
            final ServletContext context = getServletContext();
            final String searchpath = context.getRealPath("/");

            /*
             * Catch problems that application data cannot be accessed.
             */
            if (searchpath == null) {
                throw new ServletException(
                        "Error: Unable to access application data (WAR file not unpacked?)");
            }
            
            plop.set_option("searchpath={" + searchpath + "}");

            /* open protected input file with the password */
            String optlist = "password {" + in_password + "} ";
            int doc;
            if ((doc = plop.open_document(in_filename, optlist)) == -1) {
                PrintWriter writer = response.getWriter();
                
                writer.println("<html><head><title>Input document not found</title></head><body>");
                writer.println("Error: " + plop.get_errmsg() + "<br><br>");
                writer.println("For this example to work you have to access the <a href='EncryptServlet'>encryption example</a> first to get a PDF document to decrypt.<br>");
                writer.println("Back to <a href='index.html'>start page</a>.");
                writer.println("</body>");
                writer.close();
            }
            else
            {
                /* create the output file */
                optlist = "masterpassword {" + out_master + "} userpassword {"
                        + out_user + "} permissions {" + permissions + "}";
                if (plop.create_file(out_filename, optlist) == -1) {
                    throw new Exception("Error: " + plop.get_errmsg());
                }
    
                final byte[] buf = plop.get_buffer();
    
                response.setContentType("application/pdf");
                response.setContentLength(buf.length);
    
                final ServletOutputStream out = response.getOutputStream();
                out.write(buf);
                out.close();
    
                /* close input and output files */
                plop.close_document(doc);
            }
        }
        catch (PLOPException e) {
            throw new ServletException("PLOP exception occurred in "
                    + getClass().getName(), e);
        }
        catch (Exception e) {
            throw new ServletException("Exception occurred in "
                    + getClass().getName(), e);
        }
        finally {
            /* delete the PLOP object */
            if (plop != null)
                plop.delete();
        }
    }
}
