/* $Id: linearize.java,v 1.10 2008/12/01 22:00:49 rjs Exp $
 *
 * PDFlib PLOP: PDF Linearization, Optimization, Protection
 * linearization sample
 */

import java.io.*;
import com.pdflib.PLOPException;
import com.pdflib.plop;

public class linearize
{
    public static void main (String argv[])
    {
	plop plop = null;

	try {

	    final String in_filename = "PLOP-datasheet.pdf";
	    final String out_filename = "PLOP-datasheet-linearized.pdf";
	    int doc;

	    /* This is where input files live. Adjust as necessary. */
	    final String searchpath = "../data";
	    String optlist;


	    plop = new plop();

	    /* open input file */
	    optlist = "searchpath={" + searchpath + "}";
	    plop.set_option(optlist);

	    if ((doc = plop.open_document(in_filename, "")) == -1){
		System.err.println("Error: " + plop.get_errmsg());
		plop.delete();
		System.exit(2);
	    }

	    /* create the linearized output file */
	    if (plop.create_file(out_filename,
		"linearize docinfo={Author {PDFlib GmbH}}") == -1) {
		System.err.println("Error: " + plop.get_errmsg());
		plop.delete();
		System.exit(2);
	    }

	    /* close input and output files */
	    plop.close_document(doc);

        } catch (PLOPException e) {
            System.err.print("PLOP exception occurred in linearize sample:\n");
            System.err.print("[" + e.get_errnum() + "] " + e.get_apiname() +
                            ": " + e.get_errmsg() + "\n");
        } catch (Exception e) {
            System.err.println(e.getMessage());
	} finally {
	    /* delete the PLOP object */
	    if (plop != null) plop.delete();
	}
    }
}
