#---------------------------------------------------------------------------#
#          Copyright (c) 1997-2011 PDFlib GmbH. All rights reserved.        #
#---------------------------------------------------------------------------#
#    This software may not be copied or distributed except as expressly     #
#    authorized by PDFlib GmbH's general license agreement or a custom      #
#    license agreement signed by PDFlib GmbH.                               #
#    For more information about licensing please refer to www.pdflib.com.   #
#---------------------------------------------------------------------------#

# $Id: PLOP.pm,v 1.2 2011/02/21 13:02:32 rjs Exp $
#
package PDFlib::PLOP;

use strict;
use Carp;

use plop_pl 4.1;
our $VERSION = 4.1;

sub new {
    my $class = shift;
    my $self = {};
    my $plop = PLOP_new();

    bless $self, $class;
    $self->{plop} = $plop;
    PLOP_set_option($plop,  "objorient=true");

    return $self;
}

sub DESTROY {
    my $self = shift;

    PLOP_delete($self->{plop});
}

# Automatically generated methods



sub open_document {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_open_document($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub open_document_mem {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_open_document_mem($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub create_file {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_create_file($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_buffer {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_buffer($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub close_document {
    my $self = shift;
    eval {
	PLOP_close_document($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub create_pvf {
    my $self = shift;
    eval {
	PLOP_create_pvf($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub delete_pvf {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_delete_pvf($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub info_pvf {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_info_pvf($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub set_option {
    my $self = shift;
    eval {
	PLOP_set_option($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub pcos_get_number {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_pcos_get_number($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub pcos_get_string {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_pcos_get_string($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub pcos_get_stream {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_pcos_get_stream($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub convert_to_unicode {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_convert_to_unicode($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_errnum {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_errnum($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_errmsg {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_errmsg($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_apiname {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_apiname($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub get_value {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_get_value($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub set_value {
    my $self = shift;
    eval {
	PLOP_set_value($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub set_parameter {
    my $self = shift;
    eval {
	PLOP_set_parameter($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}

sub open_file {
    my $self = shift;
    my $ret;
    eval {
	$ret = PLOP_open_file($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
    return($ret);
}

sub close {
    my $self = shift;
    eval {
	PLOP_close($self->{plop}, @_);
    };
    if ($@) {
	croak($@);
    }
}
