#!/usr/bin/perl
# $Id: linearize.pl,v 1.17 2011/02/05 21:09:48 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# linearization sample
#
#

use PDFlib::PLOP 4.1;

my $in_filename  = "PLOP-datasheet.pdf";
my $out_filename = "PLOP-datasheet-linearized.pdf";

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";

my $doc;
# create a new PLOP object
my $plop = new PDFlib::PLOP;

eval {
    my $optlist;

    $optlist = sprintf("searchpath={%s}", $searchpath);
    $plop->set_option($optlist);

    # open input file
    if (($doc = $plop->open_document($in_filename, "")) == -1)
    {
	die("Error: %s", $plop->get_errmsg());
    };

    # create the linearized output file
    if ($plop->create_file($out_filename,
		"linearize docinfo={Author {PDFlib GmbH}}") == -1)
    {
	die("Error: %s", $plop->get_errmsg());
    }

    # close input and output files
    $plop->close_document($doc);
};
if ($@) {
    die("$0: PLOP Exception occurred:\n$@");
}
