#!/usr/bin/perl
# $Id: linearize.pl,v 1.1 2011/02/05 21:09:49 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# linearization sample
#
#

use plop_pl 4.1

my $in_filename  = "PLOP-datasheet.pdf";
my $out_filename = "PLOP-datasheet-linearized.pdf";

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";

my $doc;
# create a new PLOP object
my $plop = PLOP_new();

eval {
    my $optlist;

    $optlist = sprintf("searchpath={%s}", $searchpath);
    PLOP_set_option($plop, $optlist);

    # open input file
    if (($doc = PLOP_open_document($plop, $in_filename, "")) == -1)
    {
	printf("Error: %s", PLOP_get_errmsg($plop));
	PLOP_delete($plop);
	exit;
    };

    # create the linearized output file
    if (PLOP_create_file($plop, $out_filename,
		"linearize docinfo={Author {PDFlib GmbH}}") == -1)
    {
	printf("Error: %s", PLOP_get_errmsg($plop));
	PLOP_delete($plop);
	exit;
    }

    # close input and output files
    PLOP_close_document($plop, $doc);
};
if ($@) {
    printf("linearize: PLOP exception occurred:\n");
    printf("$@\n");
    PLOP_delete($plop);
    exit;
}

# delete the PLOP object
PLOP_delete($plop);
