#!/usr/bin/perl
# $Id: sign.pl,v 1.13 2011/02/07 08:36:36 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# digital signature sample
#

use PDFlib::PLOP 4.1;

my $doc;
# create a new PLOP object
my $plop = new PDFlib::PLOP;

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";

if ($#ARGV != 1) {
    die("usage: sign <infile> <outfile>\n" );
}

eval {
    my $optlist;

    # alternatives for specifying the certificate
    #
    # Windows Certificate Store (Windows only):
    #    "engine=mscapi " .
    #    "digitalid={certstore={store=My subject={DEMO PLOP user 2048}}} "
    # PFX certificate from file in search path:
    #    "engine=builtin " .
    #    "digitalid={filename=demo2048.pfx} "
    # PKCS#12 certificate from file in search path:
    #    "engine=builtin " .
    #    "digitalid={filename=demo2048.p12} "
    # PKCS#11 certificate
    #    "engine=pkcs#11 " .
    #    "digitalid={filename=cryptoki.dll} "
    #
    my $sign_opts = "sign={" .
	"appearance={fieldname=Signature1 } " .
        "engine=builtin " .
	"digitalid={filename=demo2048.p12} " .
	"password={demo} " .
	"reason={I agree to this document} " .
	"contactinfo={tel (123) 456 789} " .
	"location=Munich " .
	"}";

    $plop->set_option("searchpath={${searchpath}}");

    if (($doc = $plop->open_document($ARGV[0], "")) == -1)
    {
	die("Error: %s\n", $plop->get_errmsg());
    }

    if ($plop->create_file($ARGV[1], $sign_opts) == -1)
    {
	die("Error: %s\n", $plop->get_errmsg());
    }

    $plop->close_document($doc);
};
if ($@) {
    die("$0: PLOP Exception occurred:\n$@");
}
