<?php
    /* $Id: linearize.php,v 1.10 2011/02/07 14:19:06 rjs Exp $
     * PDFlib PLOP: PDF Linearization, Optimization, Protection
     * linearization sample
     */
$in_filename = "PLOP-datasheet.pdf";
$out_filename = "";

/* This is where input files live. Adjust as necessary. */
$searchpath = "../data ../../data";

try{
    $optlist = "";

    /* create a new PLOP object */
    $plop = new PLOP();

    $optlist = sprintf("searchpath={%s}", $searchpath);
    $plop->set_option($optlist);

    /* open input file */
    if (!($doc = $plop->open_document($in_filename, ""))) {
	die("Error: " . $plop->get_errmsg());
    }

    /* create the linearized output file */
    if (!($plop->create_file($out_filename,
		"linearize docinfo={Author {PDFlib GmbH}}"))) {
	die("Error: " . $plop->get_errmsg());
    }

    $buf = $plop->get_buffer();
    $len = strlen($buf);

    header("Content-type: application/pdf");
    header("Content-Length: $len");
    header("Content-Disposition: inline; filename=linearize.pdf");
    print $buf;

    /* close input and output files */
    $plop->close_document($doc);

}
catch (PLOPException $e) {
    die("PLOP exception occurred in linearize sample:\n" .
        "[" . $e->get_errnum() . "] " . $e->get_apiname() . ": " .
        $e->get_errmsg() . "\n");
    }
catch (Exception $e) {
    die($e);
}

$plop = 0;
?>
