# PDFlib PLOP: PDF Linearization, Optimization, Protection
# digital signature sample
#
# $Id: sign.py,v 1.3 2011/02/24 10:03:15 rjs Exp $

from sys import *
from traceback import *
from plop_py import *

# This is where input files live. Adjust as necessary.
searchpath = "../data"

if len(argv) != 3:
    raise Exception("usage: sign <infile> <outfile>\n" )

# create a new PLOP object
plop = PLOP_new()

try:
    try:
        # alternatives for specifying the certificate
        #
        # Windows Certificate Store (Windows only):
        #    "engine=mscapi " .
        #    "digitalid={certstore={store=My subject={DEMO PLOP user 2048}}} "
        # PFX certificate from file in search path:
        #    "engine=builtin " .
        #    "digitalid={filename=demo2048.pfx} "
        # PKCS#12 certificate from file in search path:
        #    "engine=builtin " .
        #    "digitalid={filename=demo2048.p12} "
        # PKCS#11 certificate
        #    "engine=pkcs#11 " .
        #    "digitalid={filename=cryptoki.dll} "
        #
        sign_opts = "sign={" \
            "appearance={fieldname=Signature1 } " \
            "engine=builtin " \
            "digitalid={filename=demo2048.p12} " \
            "password={demo} " \
            "reason={I agree to this document} " \
            "contactinfo={tel (123) 456 789} " \
            "location=Munich " \
            "}"

        optlist = "searchpath={%s}" % searchpath
        PLOP_set_option(plop, optlist)

        doc = PLOP_open_document(plop, argv[1], "")
        if (doc == -1):
            raise PLOPException("Error: %s" % PLOP_get_errmsg(plop))

        if (PLOP_create_file(plop, argv[2], sign_opts) == -1):
            raise PLOPException("Error: %s" % PLOP_get_errmsg(plop))

        PLOP_close_document(plop, doc)

    except PLOPException:
        print_exc(file=stdout)

except Exception:
    print_exc(file=stdout)

finally:
    PLOP_delete(plop)
